var thead;
var theadr;
var tbody;
var contentBox;
var fontPicker;
var toolb;
window.onload = function () {
    thead = document.getElementsByTagName("thead")[0];
    theadr = thead.getElementsByTagName("tr")[0];
    tbody = document.getElementsByTagName("tbody")[0];
    contentBox = document.querySelector("#cellline input");
    contentBox.onkeydown = contentBox.onkeypress = contentBox.onkeyup = updateCellContent;
    toolb = document.querySelector("#controlpanel");
    document.querySelector("#bld").onclick = bld;
    document.querySelector("#itl").onclick = itl;
    document.querySelector("#und").onclick = und;
    document.querySelector("#fpl").onclick = fntUp;
    document.querySelector("#fmn").onclick = fntDown;
    document.querySelector("#clf").onclick = clf;
    document.querySelector("#ext").onclick = ext;
    document.querySelector("#extr").onclick = extr;
    document.querySelector("#up").onclick = up;
    document.querySelector("#down").onclick = down;
    document.querySelector("#rrw").onclick = rrw;
    document.querySelector("#rcl").onclick = rcl;
    fontPicker = document.querySelector("#fnt");
    fontPicker.onselect = fontPicker.onchange = fnt;
    var bgcp = new ColorPicker();
    toolb.insertBefore(bgcp.label, document.querySelector("#fpl"));
    var fgcp = new ColorPicker("Bílá", "#ffffff");
    fgcp.property = "backgroundColor";
    toolb.insertBefore(fgcp.label, document.querySelector("#fpl"));
    var brdp = new BorderPicker();
    toolb.insertBefore(brdp.label, document.querySelector("#extr"));
    document.querySelector("#help").onclick = OpenHelp;
    init();
};
function bld() {
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        toogleClass(actv, "bld");
    });
}
function itl() {
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        toogleClass(actv, "itl");
    });
}
function und() {
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        toogleClass(actv, "und");
    });
}
function fnt() {
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        actv.style.fontFamily = fontPicker.selectedOptions[0].value;
    });
}
function rrw() {
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        if (actv.parentElement.parentElement) {
            actv.parentElement.parentElement.removeChild(actv.parentElement);
        }
    });
    var i = 1;
    tbody.querySelectorAll("tr").toArray().forEach(function (row) {
        row.firstChild.textContent = (i++).toString();
    });
}
function rcl() {
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        var index = actv.parentElement.children.toArray().indexOf(actv);
        theadr.removeChild(theadr.children[index]);
        tbody.querySelectorAll("tr").toArray().forEach(function (row) {
            row.removeChild(row.children[index]);
        });
    });
    var a = 'A'.charCodeAt(0);
    var first = true;
    theadr.children.toArray().forEach(function (cell) {
        if (first) {
            first = false;
            return;
        }
        cell.textContent = String.fromCharCode(a++);
    });
}
function fntUp() {
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        var curSize = window.getComputedStyle(actv).fontSize;
        if (curSize == "") {
            curSize = "16px";
        }
        curSize = parseInt(curSize) + 5;
        actv.style.fontSize = curSize + "px";
    });
}
function fntDown() {
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        var curSize = window.getComputedStyle(actv).fontSize;
        if (curSize == "") {
            curSize = "16px";
        }
        curSize = parseInt(curSize) - 5;
        actv.style.fontSize = curSize + "px";
    });
}
function clf() {
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        actv.style.fontSize = "16px";
        actv.classList.remove("bld");
        actv.classList.remove("itl");
        actv.classList.remove("und");
        actv.style.backgroundColor = "white";
        actv.style.color = "black";
        actv.style.fontFamily = "Calibri";
        actv.click();
    });
}
function ext() {
    var extended = [];
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        var index = actv.parentElement.children.toArray().indexOf(actv);
        if (extended.indexOf(index) == -1) {
            var el = theadr.children[index];
            var w = parseInt(window.getComputedStyle(el).width);
            theadr.children[index].style.width = (w + 80) + "px";
            extended.push(index);
        }
    });
}
function extr() {
    var extended = [];
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        var index = actv.parentElement.children.toArray().indexOf(actv);
        if (extended.indexOf(index) == -1) {
            var el = theadr.children[index];
            var w = parseInt(window.getComputedStyle(el).width);
            if (w == 80) {
                return;
            }
            theadr.children[index].style.width = (w - 80) + "px";
            extended.push(index);
        }
    });
}
function up() {
    var extended = [];
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        var index = actv.parentElement.parentElement.children.toArray().indexOf(actv.parentElement);
        if (extended.indexOf(index) == -1) {
            var el = tbody.children[index].firstChild;
            var w = (el.style.height);
            if (w == "") {
                w = "15px";
            }
            w = parseInt(w);
            tbody.children[index].firstChild.style.height = (w + 15) + "px";
            extended.push(index);
        }
    });
}
function down() {
    var extended = [];
    document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
        var index = actv.parentElement.parentElement.children.toArray().indexOf(actv.parentElement);
        if (extended.indexOf(index) == -1) {
            var el = tbody.children[index].firstChild;
            var w = (el.style.height);
            if (w == "") {
                w = "15px";
            }
            w = parseInt(w);
            if (w == 15) {
                return;
            }
            tbody.children[index].firstChild.style.height = (w - 15) + "px";
            extended.push(index);
        }
    });
}
function OpenHelp() {
    var a = document.createElement("a");
    a.href = "help.html";
    a.target = "_blank";
    document.body.appendChild(a);
    a.click();
    document.body.removeChild(a);
}
function updateCellContent() {
    document.querySelector(".active-cell").textContent = contentBox.value;
}
function init() {
    // thead
    theadr.appendChild(document.createElement("td"));
    for (var i = 'A'.charCodeAt(0); i <= 'Z'.charCodeAt(0); i++) {
        var td = document.createElement("td");
        td.textContent = String.fromCharCode(i);
        theadr.appendChild(td);
    }
    // tbody
    for (var i = 0; i < 100; i++) {
        var tr = document.createElement("tr");
        tbody.appendChild(tr);
        var td = document.createElement("td");
        td.textContent = (i + 1).toString();
        tr.appendChild(td);
        for (var j = 'A'.charCodeAt(0); j <= 'Z'.charCodeAt(0); j++) {
            var td = createTd();
            tr.appendChild(td);
            if (i == 0 && j == 'A'.charCodeAt(0)) {
                td.click();
            }
        }
    }
}
function clearActive() {
    var actives = document.querySelectorAll(".active-cell");
    for (var i = 0; i < actives.length; i++) {
        actives[i].classList.remove("active-cell");
    }
}
var gestureStart;
function createTd() {
    var td = document.createElement("td");
    td.onclick = function () {
        clearActive();
        this.classList.add("active-cell");
        contentBox.value = this.textContent;
        contentBox.focus();
        contentBox.select();
        var activeFont = this.style.fontFamily;
        if (activeFont == "") {
            activeFont = "Calibri";
        }
        if (activeFont[0] == '\'') {
            activeFont = activeFont.substring(1, activeFont.length - 1);
        }
        fontPicker.querySelectorAll("option").toArray().forEach(function (opt) {
            opt.selected = (opt.value == activeFont);
        });
    };
    td.onmousedown = function (e) {
        gestureStart = this;
    }.bind(td);
    td.onmousemove = function (e) {
        if (e.buttons == 0) {
            return;
        }
        clearActive();
        var gestureEnd = this;
        var y1 = tbody.children.toArray().indexOf(gestureStart.parentElement);
        var y2 = tbody.children.toArray().indexOf(gestureEnd.parentElement);
        var x1 = gestureStart.parentElement.children.toArray().indexOf(gestureStart);
        var x2 = gestureEnd.parentElement.children.toArray().indexOf(gestureEnd);
        if (y2 < y1) {
            var c = y2;
            y2 = y1;
            y1 = c;
        }
        if (x2 < x1) {
            var c = x2;
            x2 = x1;
            x1 = c;
        }
        for (var y = y1; y <= y2; y++) {
            for (var x = x1; x <= x2; x++) {
                tbody.children[y].children[x].classList.add("active-cell");
            }
        }
    }.bind(td);
    td.onmouseup = function (e) {
        this.onmousemove(e);
    }.bind(td);
    return td;
}
function toogleClass(el, cls) {
    if (el.classList.contains(cls)) {
        el.classList.remove(cls);
    }
    else {
        el.classList.add(cls);
    }
}
NodeList.prototype.toArray = HTMLCollection.prototype.toArray = function () {
    var output = [];
    for (var i = 0; i < this.length; i++) {
        output.push(this[i]);
    }
    return output;
};
Node.prototype.isIn = function (el) {
    while (el.parentElement) {
        if (el.parentElement == this) {
            return true;
        }
        el = el.parentElement;
    }
    return false;
};
var ColorPicker = (function () {
    function ColorPicker(clrl, clr) {
        if (clrl === void 0) { clrl = "Černá"; }
        if (clr === void 0) { clr = "#000000"; }
        this.label = document.createElement("div");
        this.picker = document.createElement("div");
        this.property = "color";
        this.defaultColor = "#000000";
        this.defaultColorLabel = "Černá";
        this.defaultColor = clr;
        this.defaultColorLabel = clrl;
        this.label.innerHTML = '<span class="color-preview" style="background-color: ' + this.defaultColor + '"></span> <span class="color-name">' + this.defaultColorLabel + '</span> <span class="fa fa-caret-down"></span>';
        this.label.classList.add("color-picker-label");
        this.label.appendChild(this.picker);
        this.picker.classList.add("color-picker");
        this.prepareColors();
        this.label.onclick = this.pop.bind(this);
    }
    ColorPicker.prototype.prepareColors = function () {
        var colors = [this.defaultColor, "#ff0000", "#00ff21", "#0094ff", "#ff00dc"];
        var labels = [this.defaultColorLabel, "Červená", "Zelená", "Modrá", "Růžová"];
        var ul = document.createElement("ul");
        var i = 0;
        colors.forEach(function (clr) {
            var li = document.createElement("li");
            li.innerHTML = '<span class="color-preview" style="background-color: ' + clr + '"></span> <span class="color-name">' + labels[i++] + '</span>';
            ul.appendChild(li);
            li.onclick = function (cell) {
                var cs = window.getComputedStyle(cell.querySelector(".color-preview"));
                var cn = cell.querySelector(".color-name").textContent;
                document.querySelectorAll(".active-cell").toArray().forEach(function (cl) {
                    cl.style[this.property] = cs.backgroundColor;
                    this.label.querySelector(".color-preview").style.backgroundColor = cs.backgroundColor;
                    this.label.querySelector(".color-name").textContent = cn;
                }.bind(this));
            }.bind(this, li);
        }.bind(this));
        this.picker.appendChild(ul);
        var licust = document.createElement("li");
        licust.innerHTML = '<span class="color-preview"></span><input type="text" class="custom-color"><spanc class="fa fa-paint-brush"></span>';
        licust.querySelector(".fa-paint-brush").onclick = function (input) {
            if (/^\#([0-9abcdefABCDEF]){6}$/.test(input.value)) {
                // validate
                document.querySelectorAll(".active-cell").toArray().forEach(function (cl) {
                    cl.style[this.property] = input.value;
                    this.label.querySelector(".color-preview").style.backgroundColor = input.value;
                    this.label.querySelector(".color-name").textContent = "Vlastní";
                }.bind(this));
            }
            else {
                alert("Neplatná barva");
            }
        }.bind(this, licust.querySelector(".custom-color"));
        ul.appendChild(licust);
    };
    ColorPicker.prototype.pop = function (e) {
        if (e.target.tagName.toLowerCase() == "input") {
            return;
        }
        if (this.picker.style.display == "block") {
            this.picker.style.display = "none";
        }
        else {
            this.picker.style.display = "block";
        }
    };
    return ColorPicker;
}());
var BorderPicker = (function () {
    function BorderPicker() {
        this.label = document.createElement("div");
        this.label.classList.add("border-picker-label");
        this.label.innerHTML = '<i title="nastavit okraj" class="fa fa-square-o "></i>';
        this.label.onclick = this.pop.bind(this);
        this.picker = document.createElement("div");
        this.picker.innerHTML += '<p>Nahoře: <span class="fa fa-ban"></span><span class="fa fa-pencil"></span><span class="fa fa-paint-brush"></span></p>';
        this.picker.innerHTML += '<p>Vpravo: <span class="fa fa-ban"></span><span class="fa fa-pencil"></span><span class="fa fa-paint-brush"></span></p>';
        this.picker.innerHTML += '<p>Dole: <span class="fa fa-ban"></span><span class="fa fa-pencil"></span><span class="fa fa-paint-brush"></span></p>';
        this.picker.innerHTML += '<p>Vlevo: <span class="fa fa-ban"></span><span class="fa fa-pencil"></span><span class="fa fa-paint-brush"></span></p>';
        this.picker.classList.add("color-picker");
        this.picker.classList.add("border-picker");
        this.picker.querySelectorAll(".fa").toArray().forEach(function (btn) {
            btn.onclick = function (btn) {
                var styles = [];
                styles["fa-ban"] = "0";
                styles["fa-pencil"] = "2px";
                styles["fa-paint-brush"] = "4px";
                var cls = btn.className.split(" ")[1];
                var wdth = styles[cls];
                var positions = ["Top", "Right", "Bottom", "Left"];
                var postion = positions[btn.parentElement.parentElement.children.toArray().indexOf(btn.parentElement)];
                document.querySelectorAll(".active-cell").toArray().forEach(function (actv) {
                    actv.style["border" + postion + "Width"] = wdth;
                    if (cls == "fa-ban") {
                        actv.style["border" + postion + "Color"] = "#f2f2f2";
                    }
                    else {
                        actv.style["border" + postion + "Color"] = "black";
                    }
                });
            }.bind(this, btn);
        });
        this.label.appendChild(this.picker);
    }
    BorderPicker.prototype.pop = function (e) {
        if (e.target.tagName.toLowerCase() == "input") {
            return;
        }
        if (this.picker.style.display == "block") {
            this.picker.style.display = "none";
        }
        else {
            this.picker.style.display = "block";
        }
    };
    return BorderPicker;
}());
