﻿var thead: HTMLTableSectionElement;
var theadr: HTMLTableRowElement;
var tbody: HTMLTableSectionElement;
var contentBox: HTMLInputElement;
var fontPicker: HTMLSelectElement;
var toolb: HTMLDivElement;

window.onload = function () {
	thead = <HTMLTableSectionElement>document.getElementsByTagName("thead")[0];
	theadr = thead.getElementsByTagName("tr")[0];
	tbody = document.getElementsByTagName("tbody")[0];
	contentBox = <HTMLInputElement>document.querySelector("#cellline input");
	contentBox.onkeydown = contentBox.onkeypress = contentBox.onkeyup = updateCellContent;
	toolb = <HTMLDivElement>document.querySelector("#controlpanel");
	(<HTMLButtonElement>document.querySelector("#bld")).onclick = bld;
	(<HTMLButtonElement>document.querySelector("#itl")).onclick = itl;
	(<HTMLButtonElement>document.querySelector("#und")).onclick = und;
	(<HTMLButtonElement>document.querySelector("#fpl")).onclick = fntUp;
	(<HTMLButtonElement>document.querySelector("#fmn")).onclick = fntDown;
	(<HTMLButtonElement>document.querySelector("#clf")).onclick = clf;
	(<HTMLButtonElement>document.querySelector("#ext")).onclick = ext;
	(<HTMLButtonElement>document.querySelector("#extr")).onclick = extr;
	(<HTMLButtonElement>document.querySelector("#up")).onclick = up;
	(<HTMLButtonElement>document.querySelector("#down")).onclick = down;
	(<HTMLButtonElement>document.querySelector("#rrw")).onclick = rrw;
	(<HTMLButtonElement>document.querySelector("#rcl")).onclick = rcl;
	fontPicker = (<HTMLSelectElement>document.querySelector("#fnt"));
	fontPicker.onselect = fontPicker.onchange = fnt;

	var bgcp = new ColorPicker();
	toolb.insertBefore(bgcp.label, (<HTMLButtonElement>document.querySelector("#fpl")));
	var fgcp = new ColorPicker("Bílá", "#ffffff");
	fgcp.property = "backgroundColor";
	toolb.insertBefore(fgcp.label, (<HTMLButtonElement>document.querySelector("#fpl")));

	var brdp = new BorderPicker();
	toolb.insertBefore(brdp.label, (<HTMLButtonElement>document.querySelector("#extr")));


	(<HTMLButtonElement>document.querySelector("#help")).onclick = OpenHelp;

	init();
}

function bld() {
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		toogleClass(actv, "bld");
	});
}

function itl() {
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		toogleClass(actv, "itl");
	});
}

function und() {
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		toogleClass(actv, "und");
	});
}

function fnt() {
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		actv.style.fontFamily = fontPicker.selectedOptions[0].value;
	});
}

function rrw() {
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		if (actv.parentElement.parentElement) {
			actv.parentElement.parentElement.removeChild(actv.parentElement)
		}
	});
	var i = 1;
	tbody.querySelectorAll("tr").toArray().forEach(function (row) {
		row.firstChild.textContent = (i++).toString();
	})
}

function rcl() {
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		var index = actv.parentElement.children.toArray().indexOf(actv)
		theadr.removeChild(theadr.children[index]);
		tbody.querySelectorAll("tr").toArray().forEach(function (row: HTMLTableRowElement) {
			row.removeChild(row.children[index]);
		})
	});


	var a = 'A'.charCodeAt(0)
	var first = true;
	theadr.children.toArray().forEach(function (cell) {
		if (first) {
			first = false;
			return;
		}
		cell.textContent = String.fromCharCode(a++);
	})
}

function fntUp() {
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		var curSize: any = window.getComputedStyle(actv).fontSize;
		if (curSize == "") {
			curSize = "16px";
		}
		curSize = parseInt(curSize) + 5;
		actv.style.fontSize = curSize + "px"
	});
}

function fntDown() {
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		var curSize: any = window.getComputedStyle(actv).fontSize;
		if (curSize == "") {
			curSize = "16px";
		}
		curSize = parseInt(curSize) - 5;
		actv.style.fontSize = curSize + "px"
	});
}

function clf() {
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		actv.style.fontSize = "16px";
		actv.classList.remove("bld")
		actv.classList.remove("itl")
		actv.classList.remove("und")
		actv.style.backgroundColor = "white"
		actv.style.color = "black";
		actv.style.fontFamily = "Calibri";
		actv.click();
	});

}

function ext() {
	var extended = [];
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		var index = actv.parentElement.children.toArray().indexOf(actv);
		if (extended.indexOf(index) == -1) {
			var el = <HTMLElement>theadr.children[index];
			var w = parseInt(window.getComputedStyle(el).width);
			(<HTMLElement>theadr.children[index]).style.width = (w + 80) + "px";
			extended.push(index);
		}
	});
}

function extr() {
	var extended = [];
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		var index = actv.parentElement.children.toArray().indexOf(actv);
		if (extended.indexOf(index) == -1) {
			var el = <HTMLElement>theadr.children[index];
			var w = parseInt(window.getComputedStyle(el).width);
			if (w == 80) {
				return;
			}
			(<HTMLElement>theadr.children[index]).style.width = (w - 80) + "px";
			extended.push(index);
		}
	});
}
function up() {
	var extended = [];
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		var index = actv.parentElement.parentElement.children.toArray().indexOf(actv.parentElement);
		if (extended.indexOf(index) == -1) {
			var el = <HTMLElement>tbody.children[index].firstChild;
			var w : any= (el.style.height);
			if (w == "") {
				w = "15px";
			}
			w = parseInt(w);
			(<HTMLElement>tbody.children[index].firstChild).style.height = (w + 15) + "px";
			extended.push(index);
		}
	});

}
function down() {
	var extended = [];
	document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
		var index = actv.parentElement.parentElement.children.toArray().indexOf(actv.parentElement);
		if (extended.indexOf(index) == -1) {
			var el = <HTMLElement>tbody.children[index].firstChild;
			var w: any = (el.style.height);
			if (w == "") {
				w = "15px";
			}
			w = parseInt(w);
			if (w == 15) {
				return;
			}
			(<HTMLElement>tbody.children[index].firstChild).style.height = (w - 15) + "px";
			extended.push(index);
		}
	});

}

function OpenHelp() {
	var a = document.createElement("a");
	a.href = "help.html";
	a.target = "_blank";
	document.body.appendChild(a);
	a.click();
	document.body.removeChild(a);
}

function updateCellContent() {
	document.querySelector(".active-cell").textContent = contentBox.value;
}

function init() {
	// thead
	theadr.appendChild(document.createElement("td"))
	for (var i = 'A'.charCodeAt(0) ; i <= 'Z'.charCodeAt(0) ; i++) {
		var td = document.createElement("td");
		td.textContent = String.fromCharCode(i);
		theadr.appendChild(td);
	}

	// tbody
	for (var i = 0; i < 100; i++) {
		var tr = document.createElement("tr");
		tbody.appendChild(tr);
		var td = document.createElement("td");
		td.textContent = (i + 1).toString();
		tr.appendChild(td);
		for (var j = 'A'.charCodeAt(0); j <= 'Z'.charCodeAt(0); j++) {
			var td = createTd();
			tr.appendChild(td);
			if (i == 0 && j == 'A'.charCodeAt(0)) {
				td.click();
			}
		}
	}
}

function clearActive() {
	var actives = document.querySelectorAll(".active-cell");
	for (var i = 0; i < actives.length; i++) {
		actives[i].classList.remove("active-cell");
	}
}

var gestureStart: HTMLTableCellElement;

function createTd() {
	var td = document.createElement("td");
	td.onclick = function () {
		clearActive();
		this.classList.add("active-cell");
		contentBox.value = this.textContent;
		contentBox.focus();
		contentBox.select();

		var activeFont: string = this.style.fontFamily;
		if (activeFont == "") {
			activeFont = "Calibri";
		}
		if (activeFont[0] == '\'') {
			activeFont = activeFont.substring(1, activeFont.length - 1);
		}
		fontPicker.querySelectorAll("option").toArray().forEach(function (opt: HTMLOptionElement) {
			opt.selected = (opt.value == activeFont);
		});
	}

	td.onmousedown = function (e) {
		gestureStart = this;
	}.bind(td)

	td.onmousemove = function (e: MouseEvent) {
		if (e.buttons == 0) {
			return;
		}
		clearActive();
		var gestureEnd = this;

		var y1 = tbody.children.toArray().indexOf(gestureStart.parentElement)
		var y2 = tbody.children.toArray().indexOf(gestureEnd.parentElement)
		var x1 = gestureStart.parentElement.children.toArray().indexOf(gestureStart)
		var x2 = gestureEnd.parentElement.children.toArray().indexOf(gestureEnd)

		if (y2 < y1) {
			var c: any = y2;
			y2 = y1;
			y1 = c;
		}
		if (x2 < x1) {
			var c = x2;
			x2 = x1;
			x1 = c;
		}

		for (var y = y1; y <= y2; y++) {
			for (var x = x1; x <= x2; x++) {
				(<HTMLTableRowElement>tbody.children[y]).children[x].classList.add("active-cell");
			}
		}

	}.bind(td);

	td.onmouseup = function (e) {
		this.onmousemove(e);
	}.bind(td);

	return td;
}

function toogleClass(el: HTMLElement, cls: string) {
	if (el.classList.contains(cls)) {
		el.classList.remove(cls);
	} else {
		el.classList.add(cls);
	}
}

NodeList.prototype.toArray = HTMLCollection.prototype.toArray = function () {
	var output = [];
	for (var i = 0; i < this.length; i++) {
		output.push(this[i]);
	}
	return output;
}
Node.prototype.isIn = function (el) {
	while (el.parentElement) {
		if (el.parentElement == this) {
			return true;
		}
		el = el.parentElement;
	}
	return false;
}

interface HTMLCollection {
	toArray(): Array<HTMLElement>;
}
interface NodeList {
	toArray(): Array<Node>;
}
interface Node {
	isIn(el: HTMLElement): boolean;s
}
class ColorPicker {
	public label = document.createElement("div");
	private picker = document.createElement("div");
	public property = "color";
	public defaultColor = "#000000";
	public defaultColorLabel = "Černá"

	constructor(clrl = "Černá", clr = "#000000") {
		this.defaultColor = clr;
		this.defaultColorLabel = clrl;

		this.label.innerHTML = '<span class="color-preview" style="background-color: ' + this.defaultColor + '"></span> <span class="color-name">' + this.defaultColorLabel + '</span> <span class="fa fa-caret-down"></span>';
		this.label.classList.add("color-picker-label")
		this.label.appendChild(this.picker);
		this.picker.classList.add("color-picker");
		this.prepareColors();

		this.label.onclick = this.pop.bind(this);
	}

	prepareColors() {
		var colors = [this.defaultColor, "#ff0000", "#00ff21", "#0094ff", "#ff00dc"];
		var labels = [this.defaultColorLabel, "Červená", "Zelená", "Modrá", "Růžová"];
		var ul = document.createElement("ul");
		var i = 0;
		colors.forEach(function (clr) {
			var li = document.createElement("li");
			li.innerHTML = '<span class="color-preview" style="background-color: ' + clr + '"></span> <span class="color-name">' + labels[i++] + '</span>';
			ul.appendChild(li);
			li.onclick = function (cell) {
				var cs = window.getComputedStyle(cell.querySelector(".color-preview"));
				var cn = cell.querySelector(".color-name").textContent;
				document.querySelectorAll(".active-cell").toArray().forEach(function (cl) {
					cl.style[this.property] = cs.backgroundColor;
					this.label.querySelector(".color-preview").style.backgroundColor = cs.backgroundColor;
					this.label.querySelector(".color-name").textContent = cn;
				}.bind(this))
			}.bind(this, li)
		}.bind(this));
		this.picker.appendChild(ul);

		var licust = document.createElement("li")
		licust.innerHTML = '<span class="color-preview"></span><input type="text" class="custom-color"><spanc class="fa fa-paint-brush"></span>';
		(<HTMLButtonElement>licust.querySelector(".fa-paint-brush")).onclick = function (input) {

			if (/^\#([0-9abcdefABCDEF]){6}$/.test(input.value)) {
				// validate
				document.querySelectorAll(".active-cell").toArray().forEach(function (cl) {
					cl.style[this.property] = input.value;
					this.label.querySelector(".color-preview").style.backgroundColor = input.value;
					this.label.querySelector(".color-name").textContent = "Vlastní";
				}.bind(this));
			} else {
				alert("Neplatná barva");
			}

		}.bind(this, licust.querySelector(".custom-color"))
		ul.appendChild(licust)
	}

	pop(e: MouseEvent) {
		if ((<HTMLElement>e.target).tagName.toLowerCase() == "input") {
			return;
		}
		if (this.picker.style.display == "block") {
			this.picker.style.display = "none";
		} else {
			this.picker.style.display = "block";
		}
	}
}

class BorderPicker {
	public label: HTMLDivElement;
	public picker: HTMLDivElement;

	constructor() {
		this.label = document.createElement("div");
		this.label.classList.add("border-picker-label")
		this.label.innerHTML = '<i title="nastavit okraj" class="fa fa-square-o "></i>'
		this.label.onclick = this.pop.bind(this);
		this.picker = document.createElement("div")
		this.picker.innerHTML += '<p>Nahoře: <span class="fa fa-ban"></span><span class="fa fa-pencil"></span><span class="fa fa-paint-brush"></span></p>'
		this.picker.innerHTML += '<p>Vpravo: <span class="fa fa-ban"></span><span class="fa fa-pencil"></span><span class="fa fa-paint-brush"></span></p>'
		this.picker.innerHTML += '<p>Dole: <span class="fa fa-ban"></span><span class="fa fa-pencil"></span><span class="fa fa-paint-brush"></span></p>'
		this.picker.innerHTML += '<p>Vlevo: <span class="fa fa-ban"></span><span class="fa fa-pencil"></span><span class="fa fa-paint-brush"></span></p>'
		this.picker.classList.add("color-picker")
		this.picker.classList.add("border-picker")
		this.picker.querySelectorAll(".fa").toArray().forEach(function (btn: HTMLButtonElement) {
			btn.onclick = function (btn: HTMLButtonElement) {
				var styles = [];
				styles["fa-ban"] = "0";
				styles["fa-pencil"] = "2px";
				styles["fa-paint-brush"] = "4px";
				var cls = btn.className.split(" ")[1];
				var wdth = styles[cls];

				var positions = ["Top", "Right", "Bottom", "Left"];
				var postion = positions[btn.parentElement.parentElement.children.toArray().indexOf(btn.parentElement)];

				document.querySelectorAll(".active-cell").toArray().forEach(function (actv: HTMLElement) {
					actv.style["border" + postion + "Width"] = wdth;
					if (cls == "fa-ban") {
						actv.style["border" + postion + "Color"] = "#f2f2f2";
					} else {
						actv.style["border" + postion + "Color"] = "black";
					}
				});

			}.bind(this, btn)
		});
		this.label.appendChild(this.picker);
	}

	pop(e) {
		if ((<HTMLElement>e.target).tagName.toLowerCase() == "input") {
			return;
		}
		if (this.picker.style.display == "block") {
			this.picker.style.display = "none";
		} else {
			this.picker.style.display = "block";
		}
	}
}